from sc_client.constants.sc_types import bitmasks as b
from sc_client.constants.sc_types.sc_type import ScType

UNKNOWN = ScType()

CONST = ScType(b.SC_TYPE_CONST)
VAR = ScType(b.SC_TYPE_VAR)

NODE = ScType(b.SC_TYPE_NODE)
NODE_CONST = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST)
NODE_VAR = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR)
NODE_STRUCT = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_STRUCT)
NODE_TUPLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_TUPLE)
NODE_ROLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_ROLE)
NODE_NOROLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_NOROLE)
NODE_CLASS = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_CLASS)
NODE_ABSTRACT = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_ABSTRACT)
NODE_MATERIAL = ScType(b.SC_TYPE_NODE | b.SC_TYPE_NODE_MATERIAL)
NODE_CONST_STRUCT = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_STRUCT)
NODE_CONST_TUPLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_TUPLE)
NODE_CONST_ROLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_ROLE)
NODE_CONST_NOROLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_NOROLE)
NODE_CONST_CLASS = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_CLASS)
NODE_CONST_ABSTRACT = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_ABSTRACT)
NODE_CONST_MATERIAL = ScType(b.SC_TYPE_NODE | b.SC_TYPE_CONST | b.SC_TYPE_NODE_MATERIAL)
NODE_VAR_STRUCT = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_STRUCT)
NODE_VAR_TUPLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_TUPLE)
NODE_VAR_ROLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_ROLE)
NODE_VAR_NOROLE = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_NOROLE)
NODE_VAR_CLASS = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_CLASS)
NODE_VAR_ABSTRACT = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_ABSTRACT)
NODE_VAR_MATERIAL = ScType(b.SC_TYPE_NODE | b.SC_TYPE_VAR | b.SC_TYPE_NODE_MATERIAL)

EDGE_U_COMMON = ScType(b.SC_TYPE_UEDGE_COMMON)
EDGE_D_COMMON = ScType(b.SC_TYPE_DEDGE_COMMON)
EDGE_U_COMMON_CONST = ScType(b.SC_TYPE_UEDGE_COMMON | b.SC_TYPE_CONST)
EDGE_D_COMMON_CONST = ScType(b.SC_TYPE_DEDGE_COMMON | b.SC_TYPE_CONST)
EDGE_U_COMMON_VAR = ScType(b.SC_TYPE_UEDGE_COMMON | b.SC_TYPE_VAR)
EDGE_D_COMMON_VAR = ScType(b.SC_TYPE_DEDGE_COMMON | b.SC_TYPE_VAR)
EDGE_ACCESS = ScType(b.SC_TYPE_EDGE_ACCESS)
EDGE_ACCESS_CONST_POS_PERM = ScType(b.SC_TYPE_CONST | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_PERM | b.SC_TYPE_EDGE_POS)
EDGE_ACCESS_CONST_NEG_PERM = ScType(b.SC_TYPE_CONST | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_PERM | b.SC_TYPE_EDGE_NEG)
EDGE_ACCESS_CONST_FUZ_PERM = ScType(b.SC_TYPE_CONST | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_PERM | b.SC_TYPE_EDGE_FUZ)
EDGE_ACCESS_CONST_POS_TEMP = ScType(b.SC_TYPE_CONST | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_TEMP | b.SC_TYPE_EDGE_POS)
EDGE_ACCESS_CONST_NEG_TEMP = ScType(b.SC_TYPE_CONST | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_TEMP | b.SC_TYPE_EDGE_NEG)
EDGE_ACCESS_CONST_FUZ_TEMP = ScType(b.SC_TYPE_CONST | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_TEMP | b.SC_TYPE_EDGE_FUZ)
EDGE_ACCESS_VAR_POS_PERM = ScType(b.SC_TYPE_VAR | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_PERM | b.SC_TYPE_EDGE_POS)
EDGE_ACCESS_VAR_NEG_PERM = ScType(b.SC_TYPE_VAR | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_PERM | b.SC_TYPE_EDGE_NEG)
EDGE_ACCESS_VAR_FUZ_PERM = ScType(b.SC_TYPE_VAR | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_PERM | b.SC_TYPE_EDGE_FUZ)
EDGE_ACCESS_VAR_POS_TEMP = ScType(b.SC_TYPE_VAR | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_TEMP | b.SC_TYPE_EDGE_POS)
EDGE_ACCESS_VAR_NEG_TEMP = ScType(b.SC_TYPE_VAR | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_TEMP | b.SC_TYPE_EDGE_NEG)
EDGE_ACCESS_VAR_FUZ_TEMP = ScType(b.SC_TYPE_VAR | b.SC_TYPE_EDGE_ACCESS | b.SC_TYPE_EDGE_TEMP | b.SC_TYPE_EDGE_FUZ)

LINK = ScType(b.SC_TYPE_LINK)
LINK_CONST = ScType(b.SC_TYPE_LINK | b.SC_TYPE_CONST)
LINK_VAR = ScType(b.SC_TYPE_LINK | b.SC_TYPE_VAR)
